import { GRPCHelperOpts, GRPCHelperClient } from './common';
export interface ClientFactory {
    createClient: (address: string) => GRPCHelperClient;
    closeClient: (client: GRPCHelperClient) => void;
}
export declare class HelperClientCreator implements ClientFactory {
    private opts;
    private grpcCredentials;
    private grpcOpts;
    private Service;
    private methodNames;
    private serviceDefinition;
    constructor(opts: GRPCHelperOpts);
    getMethodNames(): string[];
    private setupSvcDefs;
    private setupGRPCCredentials;
    private setupGRPCOpts;
    private getBrake;
    closeClient(client: GRPCHelperClient): void;
    createClient(host: string): GRPCHelperClient;
}
